#include <algorithm>
#include <functional>
#include <iostream>
using namespace std;

template<class T>   // T mu ein ganzzahliger Typ sein
unsigned int quersumme(T x) {
	unsigned int s = 0;
	while (x > 0) {
		s += x % 10;
		x /= 10;
	}
	return s;
}

template<class T>
class Quersumme : public unary_function<T, bool> {
public:
	explicit Quersumme(unsigned int s) : sum(s) { }
	bool operator()(T x) const { return quersumme(x) == sum; }
private:
	const unsigned int sum;
};

int main() {
	const int f[] = { 1, 3, 5, 4, 2, 4 };
	const int* i = find(f, f + 6, 4);
	if (i != f + 6)
		cout << "4 gefunden, Index " << (i - f) << endl;
	const int g[] = { 12, 10, 13, 14, 11, 15 };
	i = find_if(g, g + 6, Quersumme<int>(4));
	if (i != g + 6)
		cout << *i << " hat die Quersumme 4." << endl;
}
