#include <algorithm>
#include <functional>
#include <iostream>
using namespace std;

template<class T>
class Summe : unary_function<T, void> {
public:
	explicit Summe(const T& t = T()) : sum(t) { }
	void operator()(const T& t) { sum += t; }
	T summe() const { return sum; }
private:
	T sum;
};

void g_oder_u(int i) { cout << ((i % 2 == 0) ? 'g' : 'u'); }

int main() {
	const int f[] = { 0, 1, 2, 3, 4, 5 };
	for_each(f + 1, f + 5, g_oder_u);
	Summe<int> s = for_each(f + 1, f + 5, Summe<int>());
	cout << "  " << s.summe();
	// Kurzschreibweise
	cout << "  " << for_each(f + 1, f + 5, Summe<int>()).summe();
}
