#include <algorithm>
#include <iostream>
#include <iterator>
using namespace std;

template<class T>
class Zufall {
public:
	Zufall(T start = 0) : x(start) { }
	T operator()(T n) { return (x = (138574735 * x + 7)) % n; }
private:
	unsigned long x;
};

int main() {
	int f[] = { 1, 2, 3, 4, 5, 6, 7 };
	random_shuffle(f, f + 7);
	cout << "normal gemischt: ";
	copy(f, f + 7, ostream_iterator<int>(cout, "  "));
	typedef int T;   // eigentlich iterator_traits<int*>::difference_type statt int
	Zufall<T> z(1);
	random_shuffle(f, f + 7, z);
	cout << "\nnochmal mit z gemischt: ";
	copy(f, f + 7, ostream_iterator<int>(cout, "  "));
}
