#include <deque>
#include <iostream>
#include <iterator>
#include <list>
#include <vector>
using namespace std;

template<class Vektor, class InputIterator>
typename Vektor::iterator
insert(Vektor& v, typename Vektor::iterator vor,
		InputIterator von, InputIterator bis) {
	const typename Vektor::difference_type i = vor - v.begin();
	v.insert(vor, von, bis);
	return v.begin() + i;
}

template<class List, class InputIterator>
typename List::iterator
list_insert(List& l, typename List::iterator vor,
		InputIterator von, InputIterator bis) {
	bool erstes = (vor == l.begin());
	typename List::iterator i = vor;
	if (!erstes) --i;
	l.insert(vor, von, bis);
	if (erstes)
		 i = l.begin();
	else
		 ++i;
	return i;
}

int main() {
	/*const*/ int f[] = { 1, 2, 3, 4, 5 };
	/*const*/ int g[] = { 10, 20, 30, 40, 50 };

	vector<int> v(f, f+5);
	cout << "v = ";
	copy(v.begin(), v.end(), ostream_iterator<int>(cout, "  "));
	vector<int>::iterator vi = insert(v, v.begin() + 3, g, g + 5);
	cout << "\nv = ";
	copy(v.begin(), v.end(), ostream_iterator<int>(cout, "  "));
	cout << "\n" << (vi - v.begin()) << " = " << *vi << endl;

	deque<int> d(f, f+5);
	cout << "d = ";
	copy(d.begin(), d.end(), ostream_iterator<int>(cout, "  "));
	deque<int>::iterator di = insert(d, d.begin() + 3, g, g + 5);
	cout << "\nd = ";
	copy(d.begin(), d.end(), ostream_iterator<int>(cout, "  "));
	cout << "\n" << (di - d.begin()) << " = " << *di << endl;

	list<int> l(f, f+5);
	cout << "l = ";
	copy(l.begin(), l.end(), ostream_iterator<int>(cout, "  "));
	list<int>::iterator vor = l.begin();
	advance(vor, 3);
	list<int>::iterator li = list_insert(l, vor, g, g + 5);
	cout << "\nd = ";
	copy(l.begin(), l.end(), ostream_iterator<int>(cout, "  "));
	list<int>::difference_type i = distance(l.begin(), li);
	cout << "\n" << i << " = " << *li << endl;
}

