#include <iostream>
#include <iterator>
#include <algorithm>
using namespace std;

template<class T>
class FibIter : public iterator<input_iterator_tag, const T> {
public:
	explicit FibIter(T idx = 0) : z1(0), z2(1) {
		while (idx-- > 0)
			++ *this;
	}
	FibIter& operator++() {
		const T z3(z1 + z2);
		z1 = z2;
		z2 = z3;
		return *this;
	}
	FibIter operator++(int) {
		FibIter tmp(*this);
		++ *this;
		return tmp;
	}
	const T& operator*() const { return z2; }
	bool operator==(const FibIter& x) const { return z1 == x.z1 && z2 == x.z2; }
	bool operator!=(const FibIter& x) const { return !(*this == x); }
private:
	T z1, z2;
};

int main() {
	copy(FibIter<unsigned int>(0), FibIter<unsigned int>(7),
		ostream_iterator<unsigned int>(cout, "  "));
}
